#include "i18n.h"

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include <gtk/gtk.h>
#include "main.h"
#include "struc.h"
#include "folder.h"
#include "xpm.h"

  GtkWidget *servertree;
  GtkWidget *ent_smtp;
  GtkWidget *ent_webb;
  GtkWidget *chk_autoweb;
  GtkWidget *chk_leave;
  GtkWidget *chk_trash;
  GtkWidget *ent_password;
  GtkWidget *ent_username;
  GtkWidget *ent_pop3server;
  GtkWidget *ent_org;
  GtkWidget *ent_fullname;
  GtkWidget *ent_replyto;
  GtkWidget *ent_mail;
  GtkWidget *combo_acct;
  GtkWidget *menuitem[6];
  GtkWidget *opt_foldertype;
  GtkWidget *opt_foldertype_menu;
  GtkWidget *combo_folder;
  GtkWidget *ent_folderfile;
  GtkWidget *ent_filter;
  GtkWidget *clist;
  GtkWidget *statusbar;
  guint statusbar_id;

  GtkWidget *msgtext;
  GtkWidget *msgstatusbar;
  GtkWidget *ent_msgto;
  GtkWidget *ent_msgfrom;
  GtkWidget *ent_msgdate;
  GtkWidget *ent_msgsubj;
  GtkWidget *opt_msgparts;
  GtkWidget *opt_msgparts_menu;

  GtkWidget *cpy_win;
  GtkWidget *cpy_ent_src;
  GtkWidget *cpy_ent_s;
  GtkWidget *cpy_ent_e;
  GtkWidget *cpy_opt_acc;
  GtkWidget *cpy_opt_acc_menu;
  GtkWidget *cpy_opt_fld;
  GtkWidget *cpy_opt_fld_menu;
  int cpy_acc, cpy_fld;

  GSList *radio_group = NULL;
  GtkWidget *cfg_radio[3];
  int cfg_radio_sel;
  int autoweb_tmp;

  int acur=0;  // current account selected in combo box
  int afol=0;  // current folder selected in combo box
  
  int fol_norep=0; // flag to prevent rename-folder events
  int acc_norep=0; // flag to prevent rename-account events

  int cur_leaveonserver;
  int cur_movetotrash;

void debugmsg(char *a)
{
#ifdef _DEBUG_
  printf("%s",a);  fflush(stdout);
#endif
}
  
GtkWidget* create_main();
GtkWidget* create_msgwin();
GtkWidget* create_aboutwin();
GtkWidget* create_cpy_win(int ismove);
void Record_Second_Page();


void my_set_usize(GtkWidget *w, gint x, gint y)
{
  if ((butpixmaps==1) && (butlabels==0))
	{
	x=-1;
	y=-1;
	}
  if ((butpixmaps==1) && (butlabels==1))
	{
	y=-1;
	}
  gtk_widget_set_usize(w, x, y);
}


// This function's from the GTK+ Tutorial
GtkWidget *xpm_label_box(GtkWidget *parent, gchar *xpm[], gchar *label_text)
{
    GtkWidget *box1;
    GtkWidget *label;
    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;

//printf("\n**start"); fflush(stdout);

	if (!GTK_WIDGET_REALIZED(parent)) gtk_widget_realize(parent);

    /* create box for xpm and label */
    box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_border_width (GTK_CONTAINER (box1), 0);

  if (butpixmaps==1)
    {
    /* get style of button.. I assume it's to get the background color.
     * if someone knows the real reason, please enlighten me. */
    style = gtk_widget_get_style(parent);

    /* now on to the xpm stuff.. load xpm */
  // this is VERY slow
  pixmap = gdk_pixmap_create_from_xpm_d (parent->window, &mask,
				 &style->bg[GTK_STATE_NORMAL],
				 xpm);

    pixmapwid = gtk_pixmap_new (pixmap, mask);

    /* pack the pixmap into the box */
    gtk_box_pack_start (GTK_BOX (box1), pixmapwid, FALSE, FALSE, 1);

	}


  if (butlabels==1)
	{
    /* create label for button */
    label = gtk_label_new (label_text);

    /* pack the label into the box */
    gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);

	}

  if (butpixmaps==1) gtk_widget_show(pixmapwid);
  if (butlabels==1) gtk_widget_show(label);

//printf(" end**"); fflush(stdout);

  return (box1);
}




gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
 writeconfig();
/* GTK will emit the "destroy" signal.  Returning TRUE means
 * you don't want the window to be destroyed. */
 return (FALSE);
}


gint dont_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
/* GTK will emit the "destroy" signal.  Returning TRUE means
 * you don't want the window to be destroyed. */
 return (TRUE);
}


void DoToolTips(GtkWidget *widget, char *desc)
{
  GtkTooltips *ttip;
  GdkColor *t_fore,*t_back;

  t_fore=(GdkColor*)g_malloc( sizeof(GdkColor));
  t_back=(GdkColor*)g_malloc( sizeof(GdkColor));

  ttip=gtk_tooltips_new();
  gtk_tooltips_set_tip(ttip,widget,desc,NULL);

  if (gdk_color_parse("Yellow",t_back))
	{
    if(gdk_color_alloc(gdk_colormap_get_system(),t_back))
	  {
      gdk_color_black(gdk_colormap_get_system(),t_fore);
      gtk_tooltips_set_colors(ttip,t_back,t_fore);
	  }
	}
}


void PushStatusbar(char *desc)
{gtk_statusbar_push(GTK_STATUSBAR(statusbar),statusbar_id,desc);}

void PopStatusbar()
{gtk_statusbar_pop(GTK_STATUSBAR(statusbar),statusbar_id);}

void DoStatusbar(GtkWidget *widget, GdkEvent *event, gpointer data)
{gtk_statusbar_push(GTK_STATUSBAR(statusbar),statusbar_id,data);}

void UndoStatusbar(GtkWidget *widget, GdkEvent *event, gpointer data)
{gtk_statusbar_pop(GTK_STATUSBAR(statusbar),statusbar_id);}

void PrepStatusbar(GtkWidget *widget, char *desc)
{
  gtk_signal_connect(GTK_OBJECT(widget),"enter_notify_event",GTK_SIGNAL_FUNC(DoStatusbar),desc);
  gtk_signal_connect(GTK_OBJECT(widget),"leave_notify_event",GTK_SIGNAL_FUNC(UndoStatusbar),NULL);
}

void toggle_button_callback (GtkWidget *widget, gpointer data)
{
  if (GTK_TOGGLE_BUTTON (widget)->active) cfg_radio_sel=(int)data;
}

void autoweb_toggle_button_callback (GtkWidget *widget, gpointer data)
{
//  if (GTK_TOGGLE_BUTTON (widget)->active) cfg_radio_sel=(int)data;
if (autoweb_tmp==0) autoweb_tmp++; else autoweb_tmp=0;
}

void leave_toggle_button_callback (GtkWidget *widget, gpointer data)
{
if (cur_leaveonserver==0) cur_leaveonserver++; else cur_leaveonserver=0;
}

void trash_toggle_button_callback (GtkWidget *widget, gpointer data)
{
if (cur_movetotrash==0) cur_movetotrash++; else cur_movetotrash=0;
}

void Update_Combo(accstruc acs[], int acb)
{
GList *combo_acct_items = NULL;
int i;

debugmsg("\n update_combo");

acc_norep=1;

for(i=0;i<acb;i++) combo_acct_items=g_list_append(combo_acct_items,acs[i].accname);
gtk_combo_set_popdown_strings(GTK_COMBO(combo_acct),combo_acct_items);
g_list_free(combo_acct_items);
gtk_list_select_item(GTK_LIST(GTK_COMBO(combo_acct)->list),acur);
gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo_acct)->entry),acs[acur].accname);
//gtk_combo_set_value_in_list(GTK_COMBO(combo_acct),acur,1);
acc_norep=0;
}

void Update_FolderCombo(folderstruc folders[], int fnum)
{
GList *combo_items = NULL;
int i;

debugmsg("\n update_foldercombo");

afol=0;
fol_norep=1;

gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo_folder)->entry),folders[afol].name);

for(i=0;i<fnum;i++) combo_items=g_list_append(combo_items,folders[i].name);
gtk_combo_set_popdown_strings(GTK_COMBO(combo_folder),combo_items);
g_list_free(combo_items);

gtk_list_select_item(GTK_LIST(GTK_COMBO(combo_folder)->list),afol);
//gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo_folder)->entry),folders[afol].name);

#ifdef _DEBUG_
printf("\n * %s",folders[afol].name);
#endif

fol_norep=0;
}




void Update_FolderStatus()
{
  int i;

debugmsg("\n update_folderstatus");

  i=accbuf[acur].foldata[afol].status;
  gtk_option_menu_set_history(GTK_OPTION_MENU(opt_foldertype),i);
  gtk_entry_set_text(GTK_ENTRY(ent_folderfile),accbuf[acur].foldata[afol].file);
  if (i==5) gtk_entry_set_editable(GTK_ENTRY(ent_filter),1); else gtk_entry_set_editable(GTK_ENTRY(ent_filter),0);
}




void FolderCombo_change(GtkWidget *widget, gpointer data)
{ 
  int i,z; char *a;

#ifdef _DEBUG_
printf("\n foldercombo_change. norep: %i",fol_norep);
#endif

if (fol_norep==0) {

  a=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_folder)->entry));
  if (strcmp(a,accbuf[acur].foldata[afol].name)==0) return;
  
  if (afol>=accbuf[acur].folders) afol=0;

  z=-1;
  for(i=0;i<accbuf[acur].folders;i++) if (strcmp(a,accbuf[acur].foldata[i].name)==0) { z=i; break; }
  if (z==-1)
	{
	strcpy(accbuf[acur].foldata[afol].name,a);
	Update_FolderCombo(accbuf[acur].foldata,accbuf[acur].folders);
    gtk_list_select_item(GTK_LIST(GTK_COMBO(combo_folder)->list),afol);
	}
	else
	{
    afol=z;
    Update_FolderStatus();
	}
}	
}



void Update_Config(int a)
{

debugmsg("\n update_config");

  if ((a>=0) && (a<accountsbuf))
	{
	acur=a;
	gtk_entry_set_text(GTK_ENTRY(ent_password),accbuf[acur].password);
	gtk_entry_set_text(GTK_ENTRY(ent_username),accbuf[acur].username);
	gtk_entry_set_text(GTK_ENTRY(ent_org),accbuf[acur].org);
	gtk_entry_set_text(GTK_ENTRY(ent_fullname),accbuf[acur].fullname);
	gtk_entry_set_text(GTK_ENTRY(ent_replyto),accbuf[acur].replytoaddress);
	gtk_entry_set_text(GTK_ENTRY(ent_mail),accbuf[acur].mailaddress);
	gtk_entry_set_text(GTK_ENTRY(ent_pop3server),accbuf[acur].mailserver);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(chk_leave),accbuf[acur].leaveonserver);
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(chk_trash),accbuf[acur].movetotrash);
	cur_leaveonserver=accbuf[acur].leaveonserver;
	cur_movetotrash=accbuf[acur].movetotrash;
	afol=0;
    Update_FolderCombo(accbuf[acur].foldata, accbuf[acur].folders);
    Update_FolderStatus();
    }
}




void Combo_change(GtkWidget *widget, gpointer data)
{ 
  int i,z; char *a;

#ifdef _DEBUG_
printf("\n combo_change. norep: %i",acc_norep);
#endif

if (acc_norep==0) {
  
  a=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(combo_acct)->entry));
  if (strcmp(a,accbuf[acur].accname)==0) return;
  z=-1;
  for(i=0;i<accountsbuf;i++) if (strcmp(a,accbuf[i].accname)==0) { z=i; break; }
  if (z==-1)
	{
	strcpy(accbuf[acur].accname,a);
	Update_Combo(accbuf,accountsbuf);
    gtk_list_select_item(GTK_LIST(GTK_COMBO(combo_acct)->list),acur);
	}
	else
	  Update_Config(z);
}	  
}




void Folder_Filter(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  char *a;

debugmsg("\n folder_filter");

  a=gtk_entry_get_text(GTK_ENTRY(ent_filter));
  strcpy(accbuf[acur].foldata[afol].filter,a);
}



void Folder_File(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  char *a;

debugmsg("\n folder_file");

  a=gtk_entry_get_text(GTK_ENTRY(ent_folderfile));
  strcpy(accbuf[acur].foldata[afol].file,a);
}




void Folder_Option_Change(GtkWidget *widget, gpointer data)
{
  int s,i;

debugmsg("\n folder_option_change");

  s=(int)data;
  accbuf[acur].foldata[afol].status=s;
  
  if (s==5) gtk_entry_set_editable(GTK_ENTRY(ent_filter),1); else gtk_entry_set_editable(GTK_ENTRY(ent_filter),0);
  if ((s>0) && (s<5))
	{
    for(i=0;i<accbuf[acur].folders;i++) if ((i!=afol) && (accbuf[acur].foldata[i].status==s)) accbuf[acur].foldata[i].status=0;
    }  
}


void destroy (GtkWidget *widget, gpointer data)
{
fdel("/tmp/sandmail.webbrowser.tmp.html");
gtk_main_quit ();
}




GtkWidget* get_widget (GtkWidget *widget, gchar *widget_name)
{
  GtkWidget *found_widget;
  if (widget->parent)
    widget = gtk_widget_get_toplevel(widget);
  found_widget = gtk_object_get_data(GTK_OBJECT(widget), widget_name);
  if (!found_widget)
    g_warning("Widget not found: %s", widget_name);
  return found_widget;
}


void Open_Config(GtkWidget *widget, gpointer data)
{

debugmsg("\n open_config");

cpyaccs(accdata,&accounts,accbuf,&accountsbuf);
acur=0; afol=0;

autoweb_tmp=autoweb;
if (autoweb==0) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (chk_autoweb), FALSE);
		   else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (chk_autoweb), TRUE);

Update_Combo(accbuf,accountsbuf);
Update_Config(acur);
gtk_widget_show(config);
}


void Servertree_select (GtkWidget *root_tree, GtkWidget *child, GtkWidget *subtree);

void Prepare_ServerTree(GtkWidget *w)
{
GtkWidget *treeitem,*subtree,*subitem;
int i,j;

debugmsg("\n prepare_servertree");

    for(i=0;i<accounts;i++)
      {
      treeitem=gtk_tree_item_new_with_label(accdata[i].accname);
      gtk_tree_append(GTK_TREE(w), treeitem);
      gtk_widget_show(treeitem);
	  accdata[i].tree=treeitem; // **

      subtree=gtk_tree_new();
      gtk_tree_item_set_subtree(GTK_TREE_ITEM(treeitem),subtree);
	  gtk_signal_connect(GTK_OBJECT(subtree), "select_child",GTK_SIGNAL_FUNC(Servertree_select), subtree);

  	  for(j=0;j<accdata[i].folders;j++)			   
		{
		subitem=gtk_tree_item_new_with_label(accdata[i].foldata[j].name);
  		accdata[i].foldata[j].tree=subitem; // **
		gtk_tree_append(GTK_TREE(subtree),subitem);
		gtk_widget_show(subitem);
		}
      }
	  gtk_tree_item_expand(GTK_TREE_ITEM(accdata[acur].tree));
	  gtk_clist_clear(GTK_CLIST(clist));
}

void Record_First_Page()
{
  gchar *a;

  a=gtk_entry_get_text(GTK_ENTRY(ent_smtp));
  sprintf(smtpserver,"%s",a);
  a=gtk_entry_get_text(GTK_ENTRY(ent_webb));
  sprintf(webbrowser,"%s",a);
  autoweb=autoweb_tmp;
}

void Record_Second_Page()
{
debugmsg("\nRecord Second Page.");
  strcpy(accbuf[acur].username,gtk_entry_get_text(GTK_ENTRY(ent_username)));
  strcpy(accbuf[acur].password,gtk_entry_get_text(GTK_ENTRY(ent_password)));
  strcpy(accbuf[acur].mailserver,gtk_entry_get_text(GTK_ENTRY(ent_pop3server)));
  strcpy(accbuf[acur].mailaddress,gtk_entry_get_text(GTK_ENTRY(ent_mail)));
  strcpy(accbuf[acur].replytoaddress,gtk_entry_get_text(GTK_ENTRY(ent_replyto)));
  strcpy(accbuf[acur].fullname,gtk_entry_get_text(GTK_ENTRY(ent_fullname)));
  strcpy(accbuf[acur].org,gtk_entry_get_text(GTK_ENTRY(ent_org)));
  accbuf[acur].leaveonserver=cur_leaveonserver;
  accbuf[acur].movetotrash=cur_movetotrash;
}

void RecSecond(GtkWidget *widget, GdkEvent *event, gpointer data)
{
Record_Second_Page();
}


void Close_Config(GtkWidget *widget, gpointer data)
{

debugmsg("\n close_config");

gtk_widget_hide(config);
}

void Ok_Close_Config(GtkWidget *widget, gpointer data)
{
Record_First_Page();
Record_Second_Page();
gtk_tree_clear_items(GTK_TREE(servertree),0,accounts);
cpyaccs(accbuf,&accountsbuf,accdata,&accounts);
Prepare_ServerTree(servertree);

if (icons!=cfg_radio_sel)
  {
  icons=cfg_radio_sel;
  if (icons==0)	{ butpixmaps=1;	butlabels=0; }
  if (icons==1)	{ butpixmaps=0;	butlabels=1; }
  if (icons==2)	{ butpixmaps=1;	butlabels=1; }

/* here we destroy the signal handlers, so gtk_main_quit() and writeconfig()
   won't be called when we destroy the window */
  gtk_signal_handlers_destroy(GTK_OBJECT(msgwin)); 
  gtk_widget_destroy(msgwin);
  msgwin=create_msgwin();

  gtk_signal_handlers_destroy(GTK_OBJECT(mainwin)); 
  gtk_widget_destroy(mainwin);
  mainwin=create_main();
  gtk_widget_show(mainwin);
  }

Close_Config(widget,data);
}

void Save_Close_Config(GtkWidget *widget, gpointer data)
{
Ok_Close_Config(widget,data);
writeconfig();
}

void Update_clist()
{
  int i;

debugmsg("\n update_clist");

  PushStatusbar(_("Scanning mailbox, please wait.."));
  while(gtk_events_pending()) gtk_main_iteration(); // *important*
  
  i=Scan_Box(accdata[acur].foldata[afol].file,clist);

  PopStatusbar();

}

void view_with_browser()
{
FILE *f,*c; unsigned long p,e; pid_t pid;
 char a[128];

  p=curmail.mimepos[curmail.curpart];
  if ((curmail.curpart+1)==curmail.mimecount) e=curmail.endpos;
  else e=curmail.mimepos[curmail.curpart+1];
//  e=e-strlen(curmail.mimesep)-3;
	
  strcpy(a,accdata[acur].foldata[afol].file);
  ConvertHome(a);
  f=fopen(a,"r");
  if (f==NULL) { printf(_("\nunable to open folderfile")); fflush(stdout); return; } // **

  c=fopen("/tmp/sandmail.webbrowser.tmp.html","w");
  if (c==NULL) { printf(_("\nunable to create tempfile")); fflush(stdout); return; } // **

  fseek(f,p,SEEK_SET);
  while ((p<e) && (!feof(f)))
    {
    fputc(fgetc(f),c);
	p++;	
	}
  fclose(f);
  fclose(c);

  strcpy(a,webbrowser);
  ConvertHome(a);

  pid=fork();
  if (!pid)
    {
    execlp(a,a,"/tmp/sandmail.webbrowser.tmp.html",NULL);
    exit(0);
    }
//  pid=wait(NULL);

}


int save_quoted_printable()
{
FILE *f,*c; unsigned long p,e; pid_t pid;
 char a[128];

  if (strcasecmp(curmail.mimeenc[curmail.curpart],"quoted-printable")==0)
	{
    p=curmail.mimepos[curmail.curpart];
	if ((curmail.curpart+1)==curmail.mimecount) e=curmail.endpos;
	else e=curmail.mimepos[curmail.curpart+1];
//  e=e-strlen(curmail.mimesep)-3;
	
	strcpy(a,accdata[acur].foldata[afol].file);
    ConvertHome(a);
	f=fopen(a,"r");
    if (f==NULL) return(0);

	c=fopen("/tmp/sandmail.quoted-printable.tmp","w");
    if (c==NULL) return(0);

    fseek(f,p,SEEK_SET);
    while ((p<e) && (!feof(f)))
  	  {
	  fputc(fgetc(f),c);
	  p++;	
	  }
	fclose(f);
	fclose(c);

    pid=fork();
    if (!pid)
      {
	  execlp("mmencode","mmencode","-u","-q","/tmp/sandmail.quoted-printable.tmp","-o","/tmp/sandmail.quoted-printable.decoded.tmp",NULL);
      exit(0);
      }
    pid=wait(NULL);

	fdel("/tmp/sandmail.quoted-printable.tmp");
	return(1);
	}
return(0);
}


void msgopt_change(GtkWidget *widget, gpointer data)
{
  FILE *f; unsigned long p,e; char c[2]; int s,i; char a[128];

  s=(int)data;
  curmail.curpart=s;

  gtk_text_freeze(GTK_TEXT(msgtext));
  
  gtk_text_set_point(GTK_TEXT(msgtext),0);
  gtk_text_forward_delete(GTK_TEXT(msgtext),gtk_text_get_length((GTK_TEXT(msgtext))));

  strcpy(a,accdata[acur].foldata[afol].file);
  ConvertHome(a);
  f=fopen(a,"r");
  if (f==NULL) return;
  
  p=curmail.mimepos[s];

#ifdef _DEBUG_
  printf("\npart: %i * s: %li * endpos: %li * mimepos+1: %li",s,p,curmail.endpos,curmail.mimepos[s+1]);
#endif

  if ((s+1)==curmail.mimecount) e=curmail.endpos; else e=curmail.mimepos[s+1];
  if (strlen(curmail.mimesep)>0) e=e-strlen(curmail.mimesep)-3;

#ifdef _DEBUG_
  printf("\ns: %li * e: %li",p,e);
  printf("\nmimecount: %i",curmail.mimecount);
  printf("\nmimecont: * %s *",curmail.mimecont);
#endif

  if (strcmp(curmail.mimeenc[s],"BASE64")==0) e=curmail.mimecutpos[s];
  i=save_quoted_printable();
//  if (i==1) e=curmail.mimecutpos[s];

if (i==0) {
  fseek(f,p,SEEK_SET);
  while ((p<e) && (!feof(f)))
	{
	c[0]=fgetc(f);
	c[1]=0;
    gtk_text_insert(GTK_TEXT(msgtext),NULL,NULL,NULL,c,-1);
	p++;	
	}
}
  fclose(f);
  
  if (i==1)
	{
    f=fopen("/tmp/sandmail.quoted-printable.decoded.tmp","r");
    if (f==NULL) return;
    while (!feof(f))
	  {
	  c[0]=fgetc(f);
	  c[1]=0;
	  gtk_text_insert(GTK_TEXT(msgtext),NULL,NULL,NULL,c,-1);
	  }
	fclose(f);	
    fdel("/tmp/sandmail.quoted-printable.decoded.tmp");
	}

  gtk_text_thaw(GTK_TEXT(msgtext));

  strcpy(a,curmail.mimecont[s]);
  if ((strstr(a,"text/html")!=NULL) && (autoweb==1)) view_with_browser(); // *
}




void clist_select(GtkWidget *clist,gint row,gint column,GdkEventButton *event,gpointer data)
{
  gchar *text;
  FILE *f; unsigned long p,e; int i; char a[128];
  
debugmsg("\nclist_select()");

//  msgwin=create_msgwin();

  gtk_clist_get_text(GTK_CLIST(clist),row,0,&text);
  gtk_entry_set_text(GTK_ENTRY(ent_msgdate),text);
  gtk_entry_set_position(GTK_ENTRY(ent_msgdate),0);

  gtk_clist_get_text(GTK_CLIST(clist),row,1,&text);
  gtk_entry_set_text(GTK_ENTRY(ent_msgsubj),text);
  gtk_entry_set_position(GTK_ENTRY(ent_msgsubj),0);

  gtk_clist_get_text(GTK_CLIST(clist),row,2,&text);
  gtk_entry_set_text(GTK_ENTRY(ent_msgfrom),text);
  gtk_entry_set_position(GTK_ENTRY(ent_msgfrom),0);

  gtk_clist_get_text(GTK_CLIST(clist),row,3,&text);
  gtk_entry_set_text(GTK_ENTRY(ent_msgto),text);
  gtk_entry_set_position(GTK_ENTRY(ent_msgto),0);


  gtk_widget_realize(msgtext);
  gtk_text_set_word_wrap(GTK_TEXT(msgtext),1);

  strcpy(a,accdata[acur].foldata[afol].file);
  ConvertHome(a);
  f=fopen(a,"r");
  if (f==NULL) return;
  p=(int)gtk_clist_get_row_data(GTK_CLIST(clist),row);
  
  i=row+1;
  if (i==totmail) { fseek(f,0,SEEK_END); e=ftell(f); }
	  else e=(int)gtk_clist_get_row_data(GTK_CLIST(clist),i);

  curmail.curpart=0;
  curmail.startpos=p;
  curmail.endpos=e;

debugmsg("\ncalling scan_mail");

  Scan_Mail(f);

debugmsg("\nscan_mail returned");

  fclose(f);

  opt_msgparts_menu = gtk_menu_new();

  for(i=0;i<curmail.mimecount;i++)
    {
    curmail.mimeitem[i]=gtk_menu_item_new_with_label(curmail.mimedesc[i]);
    gtk_widget_show(curmail.mimeitem[i]);
    gtk_signal_connect_object(GTK_OBJECT(curmail.mimeitem[i]),"activate",GTK_SIGNAL_FUNC(msgopt_change),(gpointer)i);
    gtk_menu_append(GTK_MENU(opt_msgparts_menu), curmail.mimeitem[i]);
	}
  gtk_option_menu_set_menu(GTK_OPTION_MENU(opt_msgparts), opt_msgparts_menu);

debugmsg("\ncalling msgopt_change");

msgopt_change(opt_msgparts,(gpointer)0);

debugmsg("\ndisplaying window\n");

gtk_widget_show(msgwin);
}



void msgmenu_decode_filesel_ok(GtkWidget *w, GtkFileSelection *fs)
{
  pid_t pid;
  char f[128];
  sprintf(f,"%s",gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
  gtk_object_destroy(GTK_OBJECT(fs));

  pid=fork();
  if (!pid)
    {
	execlp("mmencode","mmencode","-u","/tmp/sandmail.base64.tmp","-o",f,NULL);
    exit(0);
    }
  pid=wait(NULL);
  fdel("/tmp/sandmail.base64.tmp");
}




void msgmenu_export_filesel_ok(GtkWidget *w, GtkFileSelection *fs)
{
  char fn[128]; int i;
  sprintf(fn,"%s",gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
  gtk_object_destroy(GTK_OBJECT(fs));

  fdel(fn);
  i=CopyMsg(accdata[acur].foldata[afol].file,curmail.startpos,curmail.endpos,fn);
  if (i!=0)
	{
	printf("\nmsgmenu_export_filesel_ok: CopyMsg returned error: %i",i); // **
	fflush(stdout);	
	}
}



void cpymove_do(GtkWidget *widget, gpointer data)
{
int cpymove; unsigned long p,e; char fn[128]; int i;

  cpymove=(int)data;

  sprintf(fn,"%s",gtk_entry_get_text(GTK_ENTRY(cpy_ent_s)));
  p=atoi(fn);
  sprintf(fn,"%s",gtk_entry_get_text(GTK_ENTRY(cpy_ent_e)));
  e=atoi(fn);
  sprintf(fn,"%s",gtk_entry_get_text(GTK_ENTRY(cpy_ent_src)));

#ifdef _DEBUG_
  printf("\n\ncpymove_do called");
  printf("\n\nmove: %i * p: %li * e: %li * fn: %s",cpymove,p,e,fn);
  fflush(stdout);
#endif

  i=CopyMsg(fn,p,e,accdata[cpy_acc].foldata[cpy_fld].file);
  if (i!=0) printf("\nCopyMsg returned error: %i",i); // **
  if ((i==0) && (cpymove==1))
	{
	i=DelMsg(fn,p,e);
    if (i!=0) printf("\nDelMsg returned error: %i",i); // **
	}
  gtk_widget_destroy(cpy_win);
  Update_clist();
}




void cpy_opt_fld_change(GtkWidget *widget, gpointer data)
{
  cpy_fld=(int)data;
}


void cpy_opt_acc_change(GtkWidget *widget, gpointer data)
{
  GtkWidget *item;
  int s,i;


  s=(int)data;
  cpy_acc=s;

  cpy_opt_fld_menu=gtk_menu_new();
  for(i=0;i<accdata[s].folders;i++)
    {
    item=gtk_menu_item_new_with_label(accdata[s].foldata[i].name);
    gtk_widget_show(item);
    gtk_signal_connect_object(GTK_OBJECT(item),"activate",GTK_SIGNAL_FUNC(cpy_opt_fld_change),(gpointer)i);
    gtk_menu_append(GTK_MENU(cpy_opt_fld_menu),item);
    }
  gtk_option_menu_set_menu(GTK_OPTION_MENU(cpy_opt_fld), cpy_opt_fld_menu);

}

void msgmenu_func(GtkWidget *widget, gpointer data)
{
FILE *f,*c; int s,i; unsigned long p,e; char a[128];
/*	0: reply
	1: forward
	2: copy
	3: move
	4: del
	5: decode
	6: export
	7: view as html
*/
  s=(int)data;

  if ((s==2) || (s==3))
	{
    char text[128];
	GtkWidget *item;

	if (s==2)
	  cpy_win=create_cpy_win(0);
	else
	  cpy_win=create_cpy_win(1);

	sprintf(text,"%s",accdata[acur].foldata[afol].file);
    gtk_entry_set_text(GTK_ENTRY(cpy_ent_src),text);
    gtk_entry_set_position(GTK_ENTRY(cpy_ent_src),0);

	sprintf(text,"%li",curmail.startpos);
    gtk_entry_set_text(GTK_ENTRY(cpy_ent_s),text);
    gtk_entry_set_position(GTK_ENTRY(cpy_ent_s),0);

	sprintf(text,"%li",curmail.endpos);
    gtk_entry_set_text(GTK_ENTRY(cpy_ent_e),text);
    gtk_entry_set_position(GTK_ENTRY(cpy_ent_e),0);

	cpy_opt_acc_menu=gtk_menu_new();
	for(i=0;i<accounts;i++)
      {
  	  item=gtk_menu_item_new_with_label(accdata[i].accname);
  	  gtk_widget_show(item);
  	  gtk_signal_connect_object(GTK_OBJECT(item),"activate",GTK_SIGNAL_FUNC(cpy_opt_acc_change),(gpointer)i);
  	  gtk_menu_append(GTK_MENU(cpy_opt_acc_menu),item);
	  }
	gtk_option_menu_set_menu(GTK_OPTION_MENU(cpy_opt_acc), cpy_opt_acc_menu);

	cpy_opt_acc_change(item,(gpointer)0);

	cpy_acc=0;
	cpy_fld=0;
	gtk_widget_show(cpy_win);

	}

  
  
  if (s==4)
	{
    p=DelMsg(accdata[acur].foldata[afol].file,curmail.startpos,curmail.endpos);
	if (p!=0) printf("\ndelmsg returned error:  %li",p); // **
	}

  if ((s==5) && (strcmp(curmail.mimeenc[curmail.curpart],"BASE64")==0))
	{
	GtkWidget *filew;
	
    p=curmail.mimecutpos[curmail.curpart];
	if ((curmail.curpart+1)==curmail.mimecount) e=curmail.endpos;
	else e=curmail.mimepos[curmail.curpart+1];
    e=e-strlen(curmail.mimesep)-3;
	
	strcpy(a,accdata[acur].foldata[afol].file);
	ConvertHome(a);
	f=fopen(a,"r");
    if (f==NULL) return;

	c=fopen("/tmp/sandmail.base64.tmp","w");
    if (c==NULL) return;

    fseek(f,p,SEEK_SET);
    while ((p<e) && (!feof(f)))
  	  {
	  fputc(fgetc(f),c);
	  p++;	
	  }
	fclose(f);
	fclose(c);

	filew = gtk_file_selection_new (_("Decode MIME Attachment"));
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filew)->ok_button),"clicked",(GtkSignalFunc)msgmenu_decode_filesel_ok,filew);
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION (filew)->cancel_button),"clicked",(GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(filew));
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(filew),curmail.mimefile[curmail.curpart]);
    gtk_widget_show(filew);
	}
  if (s==6)
	{
	GtkWidget *filew;
	filew=gtk_file_selection_new(_("Export Message"));
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filew)->ok_button),"clicked",(GtkSignalFunc)msgmenu_export_filesel_ok,filew);
    gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION (filew)->cancel_button),"clicked",(GtkSignalFunc)gtk_widget_destroy,GTK_OBJECT(filew));
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(filew),_("savedmsg.txt"));
    gtk_widget_show(filew);
	}

  if (s==7)
	{
	view_with_browser();
	}


}

void Servertree_select (GtkWidget *root_tree, GtkWidget *child, GtkWidget *subtree)
{
  GList *i;
  gchar *name;
  GtkLabel *label;
  GtkWidget *item;
  int j,l,a,f;

debugmsg("\n servertree_select");

  i = GTK_TREE_SELECTION(servertree);
  item = GTK_WIDGET (i->data);
  label = GTK_LABEL (GTK_BIN (item)->child);
  gtk_label_get (label, &name);

  a=-1; f=-1;
  for(j=0;((j<accounts) && (a<0));j++) for(l=0;l<accdata[j].folders;l++) 
    if (GTK_WIDGET(child)==GTK_WIDGET(accdata[j].foldata[l].tree)) { a=j; f=l; break; }
	
  // check if clicked on subtree and we aren't there
  if ((a==-1) && (f==-1)) return;
  if (acur==0) acur++;
  if ((a!=acur) || (f!=afol)) { acur=a; afol=f; Update_clist(); }
}



void new_account(GtkWidget *widget, gpointer data)
{
int i;

debugmsg("\n new_account");

Record_Second_Page();

i=accountsbuf;
accountsbuf++;
strcpy(accbuf[i].accname,_("new account"));
strcpy(accbuf[i].username,"");
strcpy(accbuf[i].password,"");
strcpy(accbuf[i].mailserver,"");
strcpy(accbuf[i].mailaddress,"");
strcpy(accbuf[i].replytoaddress,"");
strcpy(accbuf[i].fullname,"");
strcpy(accbuf[i].org,"");
accbuf[i].leaveonserver=0;
accbuf[i].movetotrash=0;

accbuf[i].folders=1;

strcpy(accbuf[i].foldata[0].name,_("Inbox"));
accbuf[i].foldata[0].status=1;
strcpy(accbuf[i].foldata[0].filter,"");
strcpy(accbuf[i].foldata[0].file,"");

Update_Combo(accbuf,accountsbuf);
Update_FolderCombo(accbuf[i].foldata,accbuf[i].folders);

gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo_acct)->entry),accbuf[i].accname);
Combo_change(combo_acct,NULL);
}



void del_account(GtkWidget *widget, gpointer data)
{
int a,i,j;

a=acur;

if (accountsbuf>1)
  {
  for(i=a+1;i<accountsbuf;i++)
    {
    strcpy(accbuf[i-1].accname,accbuf[i].accname);
    strcpy(accbuf[i-1].username,accbuf[i].username);
    strcpy(accbuf[i-1].password,accbuf[i].password);
	strcpy(accbuf[i-1].mailserver,accbuf[i].mailserver);
    strcpy(accbuf[i-1].mailaddress,accbuf[i].mailaddress);
	strcpy(accbuf[i-1].replytoaddress,accbuf[i].replytoaddress);
    strcpy(accbuf[i-1].fullname,accbuf[i].fullname);
	strcpy(accbuf[i-1].org,accbuf[i].org);
    accbuf[i-1].leaveonserver=accbuf[i].leaveonserver;
    accbuf[i-1].movetotrash=accbuf[i].movetotrash;
    accbuf[i-1].folders=accbuf[i].folders;
	for(j=0;j<accbuf[i-1].folders;j++)
	  {
	  strcpy(accbuf[i-1].foldata[j].name,accbuf[i].foldata[j].name);
	  accbuf[i-1].foldata[j].status=accbuf[i].foldata[j].status;
	  strcpy(accbuf[i-1].foldata[j].filter,accbuf[i].foldata[j].filter);
	  strcpy(accbuf[i-1].foldata[j].file,accbuf[i].foldata[j].file);
	  }
    }
  accountsbuf--;
  acur=0; afol=0;

  Update_Combo(accbuf,accountsbuf);
  gtk_list_select_item(GTK_LIST(GTK_COMBO(combo_acct)->list),acur);
  Update_Config(acur);
  }

}



void new_folder(GtkWidget *widget, gpointer data)
{
int i,a;

debugmsg("\n new_folder");

a=acur;
i=accbuf[a].folders;
accbuf[a].folders++;
afol=i;

strcpy(accbuf[a].foldata[i].name,_("New folder"));
accbuf[a].foldata[i].status=0;
strcpy(accbuf[a].foldata[i].filter,"");
strcpy(accbuf[a].foldata[i].file,"");

Update_FolderCombo(accbuf[a].foldata,accbuf[a].folders);

gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(combo_folder)->entry),accbuf[a].foldata[i].name);
FolderCombo_change(combo_folder,NULL);

}


void del_folder(GtkWidget *widget, gpointer data)
{
int a,i;
a=acur;

if (accbuf[a].folders>1)
  {
  for(i=afol+1;i<accbuf[a].folders;i++)
    {
    strcpy(accbuf[a].foldata[i-1].name,accbuf[a].foldata[i].name);
    accbuf[a].foldata[i-1].status=accbuf[a].foldata[i].status;
    strcpy(accbuf[a].foldata[i-1].filter,accbuf[a].foldata[i].filter);
    strcpy(accbuf[a].foldata[i-1].file,accbuf[a].foldata[i].file);
    }
  accbuf[a].folders--;
//	if ((afol>0) && (afol==accbuf[a].folders)) afol--;
  afol=0;

  Update_FolderCombo(accbuf[a].foldata,accbuf[a].folders);
  Update_FolderStatus();
  }
}



GtkWidget*
create_main ()
{
  GtkWidget *win;
  GtkWidget *vbox1;
  GtkWidget *handlebox;
  GtkWidget *hbox1;
  GtkWidget *button_get;
  GtkWidget *button_send;
  GtkWidget *button_opt;
  GtkWidget *button_about;
  GtkWidget *hpaned;
  GtkWidget *labelFrom;
  GtkWidget *labelDate;
  GtkWidget *labelTo;
  GtkWidget *labelSubj;
  GtkWidget *labelFlags;
  GtkWidget *scrolledwindow1;
  GtkWidget *box1;

  win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data(GTK_OBJECT(win), "sandmail", win);
  gtk_widget_set_usize(win, 650, 325);
  gtk_window_set_title(GTK_WINDOW(win), _("Sandmail"));
  gtk_window_set_policy(GTK_WINDOW(win), TRUE, TRUE, FALSE);
  gtk_window_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
  gtk_widget_realize(win);

  gtk_signal_connect (GTK_OBJECT(win),"delete_event",GTK_SIGNAL_FUNC(delete_event),NULL);
  gtk_signal_connect (GTK_OBJECT(win),"destroy",GTK_SIGNAL_FUNC(destroy),NULL);


  vbox1 = gtk_vbox_new(FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(win), "vbox1", vbox1);
  gtk_widget_show(vbox1);
  gtk_container_add(GTK_CONTAINER(win), vbox1);

  handlebox = gtk_handle_box_new();
  gtk_object_set_data(GTK_OBJECT(win), "handlebox", handlebox);
  gtk_widget_show(handlebox);
  gtk_box_pack_start(GTK_BOX(vbox1), handlebox, FALSE, TRUE, 0);
  DoToolTips(handlebox, _("Click and drag to move this cool toolbar"));

  hbox1 = gtk_hbox_new(FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(win), "hbox1", hbox1);
  gtk_widget_show(hbox1);
  gtk_container_add(GTK_CONTAINER(handlebox), hbox1);

  button_get = gtk_button_new ();
  box1 = xpm_label_box(hbox1,reply_xpm,_("Get mail"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(button_get),box1);
  gtk_widget_show(button_get);
  gtk_box_pack_start(GTK_BOX(hbox1), button_get, FALSE, TRUE, 0);
  my_set_usize(button_get, 70, -1);
  
  DoToolTips(button_get, _("Check for mail"));


  button_send = gtk_button_new ();
  box1 = xpm_label_box(hbox1,forward_xpm,_("Send mail"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(button_send),box1);
  gtk_widget_show(button_send);
  gtk_box_pack_start(GTK_BOX(hbox1), button_send, FALSE, TRUE, 0);
  my_set_usize(button_send, 70, -1);
  
  DoToolTips(button_send, _("Send mail in Outbox"));

  button_opt = gtk_button_new ();
  box1 = xpm_label_box(hbox1,options_xpm,_("Options"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(button_opt),box1);
  gtk_widget_show(button_opt);
  gtk_box_pack_start(GTK_BOX(hbox1), button_opt, FALSE, TRUE, 0);
  my_set_usize(button_opt, 70, -1);


  DoToolTips(button_opt, _("Options..."));
  gtk_signal_connect (GTK_OBJECT(button_opt),"clicked",GTK_SIGNAL_FUNC(Open_Config),NULL);
							

  button_about = gtk_button_new ();
  box1 = xpm_label_box(hbox1,about_xpm,_("About"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(button_about),box1);
  gtk_widget_show(button_about);
  gtk_box_pack_end(GTK_BOX(hbox1), button_about, FALSE, TRUE, 0);
  my_set_usize(button_about, 70, -1);

  gtk_signal_connect(GTK_OBJECT(button_about),"clicked",GTK_SIGNAL_FUNC(create_aboutwin),NULL);
  DoToolTips(button_about, _("About the author"));


  hpaned = gtk_hpaned_new();
  gtk_object_set_data(GTK_OBJECT(win), "hpaned", hpaned);
  gtk_widget_show(hpaned);
  gtk_box_pack_start(GTK_BOX(vbox1), hpaned, TRUE, TRUE, 0);
  DoToolTips(hpaned, _("Click and drag to resize"));

  scrolledwindow1 = gtk_scrolled_window_new(NULL, NULL);
  gtk_object_set_data(GTK_OBJECT(win), "scrolledwindow1", scrolledwindow1);
  gtk_widget_show(scrolledwindow1);
  gtk_container_add(GTK_CONTAINER(hpaned), scrolledwindow1);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize(scrolledwindow1, 120, -1);

  servertree = gtk_tree_new();
  gtk_object_set_data(GTK_OBJECT(win), "servertree", servertree);
  gtk_tree_set_selection_mode (GTK_TREE(servertree),GTK_SELECTION_BROWSE);
  
  gtk_widget_show(servertree);
  gtk_container_add(GTK_CONTAINER(scrolledwindow1), servertree);
  DoToolTips(servertree, _("Select the server folder you wish to browse"));

  gtk_signal_connect (GTK_OBJECT(servertree), "select_child", GTK_SIGNAL_FUNC(Servertree_select), servertree);
  
  clist = gtk_clist_new(5);
  gtk_object_set_data(GTK_OBJECT(win), "clist", clist);
  gtk_widget_show(clist);
  gtk_container_add(GTK_CONTAINER(hpaned), clist);
  gtk_clist_set_column_width(GTK_CLIST(clist), 0, 40);
  gtk_clist_set_column_width(GTK_CLIST(clist), 1, 140);
  gtk_clist_set_column_width(GTK_CLIST(clist), 2, 120);
  gtk_clist_set_column_width(GTK_CLIST(clist), 3, 120);
  gtk_clist_set_column_width(GTK_CLIST(clist), 4, 15);
  gtk_clist_column_titles_show(GTK_CLIST(clist));
  gtk_clist_set_policy(GTK_CLIST(clist), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_signal_connect(GTK_OBJECT(clist),"select_row",GTK_SIGNAL_FUNC(clist_select),NULL);

  Prepare_ServerTree(servertree);

  labelFrom = gtk_label_new(_("From"));
  gtk_object_set_data(GTK_OBJECT(win), "labelFrom", labelFrom);
  gtk_widget_show(labelFrom);
  gtk_clist_set_column_widget(GTK_CLIST(clist), 2, labelFrom);
  gtk_label_set_justify(GTK_LABEL(labelFrom), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(labelFrom), 0, 0);

  labelDate = gtk_label_new(_("Date"));
  gtk_object_set_data(GTK_OBJECT(win), "labelDate", labelDate);
  gtk_widget_show(labelDate);
  gtk_clist_set_column_widget(GTK_CLIST(clist), 0, labelDate);
  gtk_label_set_justify(GTK_LABEL(labelDate), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(labelDate), 0, 0);

  labelTo = gtk_label_new(_("To"));
  gtk_object_set_data(GTK_OBJECT(win), "labelTo", labelTo);
  gtk_widget_show(labelTo);
  gtk_clist_set_column_widget(GTK_CLIST(clist), 3, labelTo);
  gtk_label_set_justify(GTK_LABEL(labelTo), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(labelTo), 0, 0);

  labelSubj = gtk_label_new(_("Subject"));
  gtk_object_set_data(GTK_OBJECT(win), "labelSubj", labelSubj);
  gtk_widget_show(labelSubj);
  gtk_clist_set_column_widget(GTK_CLIST(clist), 1, labelSubj);
  gtk_label_set_justify(GTK_LABEL(labelSubj), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(labelSubj), 0, 0);

  labelFlags = gtk_label_new(_("Flags"));
  gtk_object_set_data(GTK_OBJECT(win), "labelFlags", labelFlags);
  gtk_widget_show(labelFlags);
  gtk_clist_set_column_widget(GTK_CLIST(clist), 4, labelFlags);
  gtk_label_set_justify(GTK_LABEL(labelFlags), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(labelFlags), 0, 0.5);

  statusbar = gtk_statusbar_new();
  gtk_object_set_data(GTK_OBJECT(win), "statusbar", statusbar);
  gtk_widget_show(statusbar);
  gtk_box_pack_start(GTK_BOX(vbox1), statusbar, FALSE, TRUE, 0);
  statusbar_id=gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar),"Main window Statusbar");
  DoToolTips(statusbar, _("This is the app's statusbar. I don't know if I should keep it. Send comments. Thanks."));
  
  return win;
}



GtkWidget*
create_config ()
{
  GtkWidget *config;
  GtkWidget *dialog_vbox1;
  GtkWidget *notebook1;
  GtkWidget *hbox1;
  GtkWidget *label3;
  GtkWidget *table1,*table0;
  GtkWidget *label11;
  GtkWidget *label10;
  GtkWidget *label17;
  GtkWidget *label16;
  GtkWidget *label18;
  GtkWidget *label9;
  GtkWidget *label8;
  GtkWidget *label7;
  GtkWidget *label6;
  GtkWidget *label5;
  GtkWidget *label4;
  GtkWidget *dialog_action_area1;
  GtkWidget *tlabel1, *tlabel2;
  GtkWidget *hbox3;
  GtkWidget *hbox2;
  GtkWidget *label12;
  GtkWidget *vseparator1;
  
  GtkWidget *button_new;
  GtkWidget *button_del;
  GtkWidget *button_ok;
  GtkWidget *button_save;
  GtkWidget *button_cancel;
  GtkWidget *but_newfolder;
  GtkWidget *but_delfolder;

  GtkWidget *radio_vbox;
  GtkWidget *radio_frame;
  GtkWidget *vbox1;
  
  config = gtk_dialog_new();
  gtk_object_set_data(GTK_OBJECT(config), "config", config);
  gtk_window_set_title(GTK_WINDOW(config), _("Configuration"));
  gtk_window_set_policy(GTK_WINDOW(config), FALSE, FALSE, TRUE);
  gtk_window_position (GTK_WINDOW (config), GTK_WIN_POS_CENTER);
  gtk_signal_connect(GTK_OBJECT(config),"delete_event",GTK_SIGNAL_FUNC(Close_Config),NULL);

  dialog_vbox1 = GTK_DIALOG (config)->vbox;
  gtk_object_set_data(GTK_OBJECT(config), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show(dialog_vbox1);

  notebook1 = gtk_notebook_new();
  gtk_object_set_data(GTK_OBJECT(config), "notebook1", notebook1);
  gtk_notebook_set_tab_border(GTK_NOTEBOOK(notebook1), 2);
  gtk_widget_show(notebook1);
  gtk_box_pack_start(GTK_BOX(dialog_vbox1), notebook1, TRUE, TRUE, 0);


//  table0 = gtk_table_new(3, 3, FALSE);
  table0 = gtk_table_new(5, 3, FALSE); // y,x
  gtk_widget_show(table0);
  gtk_table_set_col_spacings(GTK_TABLE(table0), 3);

  tlabel1=gtk_label_new(_("General"));
  gtk_widget_show(tlabel1);
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook1),table0,tlabel1);



  label3 = gtk_label_new("");
  gtk_widget_show(label3);
   gtk_table_attach (GTK_TABLE (table0), label3, 0, 3, 2, 3,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  label3 = gtk_label_new("");
  gtk_widget_show(label3);
  gtk_table_attach (GTK_TABLE (table0), label3, 2, 3, 0, 2,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);


  label3 = gtk_label_new(_("SMTP server:"));
  gtk_object_set_data(GTK_OBJECT(config), "label3", label3);
  gtk_widget_show(label3);
  gtk_table_attach(GTK_TABLE(table0), label3, 0, 1, 0, 1,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label3), 1, 0.5);

  ent_smtp = gtk_entry_new_with_max_length(50);
  gtk_entry_set_text(GTK_ENTRY(ent_smtp),smtpserver);
  gtk_object_set_data(GTK_OBJECT(config), "ent_smtp", ent_smtp);
  gtk_widget_show(ent_smtp);
  gtk_table_attach(GTK_TABLE(table0), ent_smtp, 1, 2, 0, 1,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  label3 = gtk_label_new(_("Web Browser:"));
  gtk_object_set_data(GTK_OBJECT(config), "label3", label3);
  gtk_widget_show(label3);
  gtk_table_attach(GTK_TABLE(table0), label3, 0, 1, 1, 2,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label3), 1, 0.5);

  ent_webb = gtk_entry_new_with_max_length(50);
  gtk_entry_set_text(GTK_ENTRY(ent_webb),webbrowser);
  gtk_widget_show(ent_webb);
  gtk_table_attach(GTK_TABLE(table0), ent_webb, 1, 2, 1, 2,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  chk_autoweb = gtk_check_button_new_with_label(_("Launch web browser automatically when text/html detected"));
  gtk_widget_show(chk_autoweb);
  gtk_table_attach(GTK_TABLE(table0), chk_autoweb, 0, 2, 2, 3,
                   GTK_EXPAND | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  if (autoweb==0) gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (chk_autoweb), FALSE);
		     else gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON (chk_autoweb), TRUE);
  gtk_signal_connect(GTK_OBJECT(chk_autoweb),"toggled",GTK_SIGNAL_FUNC(autoweb_toggle_button_callback),NULL);

  radio_frame = gtk_frame_new (_(" Show Toolbar Icons As "));
  gtk_container_border_width (GTK_CONTAINER (radio_frame), 5);
  gtk_widget_show (radio_frame);
  gtk_widget_set_usize(radio_frame,-1,-1);
  gtk_frame_set_label_align (GTK_FRAME(radio_frame), 0.02, 0.5);
  gtk_table_attach(GTK_TABLE(table0), radio_frame, 1, 2, 3, 4,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  radio_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (radio_vbox);
  gtk_container_add (GTK_CONTAINER (radio_frame), radio_vbox);

  cfg_radio[0] = gtk_radio_button_new_with_label (radio_group, _("Pictures"));
  radio_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cfg_radio[0]));
  gtk_widget_show (cfg_radio[0]);
  gtk_widget_set_usize(cfg_radio[0],-1,-1);
  gtk_box_pack_start (GTK_BOX (radio_vbox), cfg_radio[0], FALSE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(cfg_radio[0]),"toggled",GTK_SIGNAL_FUNC(toggle_button_callback),(gpointer)0);

  cfg_radio[1] = gtk_radio_button_new_with_label (radio_group, _("Text"));
  radio_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cfg_radio[1]));
  gtk_widget_show (cfg_radio[1]);
  gtk_widget_set_usize(cfg_radio[1],-1,-1);
  gtk_box_pack_start (GTK_BOX (radio_vbox), cfg_radio[1], FALSE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(cfg_radio[1]),"toggled",GTK_SIGNAL_FUNC(toggle_button_callback),(gpointer)1);

  cfg_radio[2] = gtk_radio_button_new_with_label (radio_group, _("Pictures & Text"));
  radio_group = gtk_radio_button_group (GTK_RADIO_BUTTON (cfg_radio[2]));
  gtk_widget_show (cfg_radio[2]);
  gtk_widget_set_usize(cfg_radio[2],-1,-1);
  gtk_box_pack_start (GTK_BOX (radio_vbox), cfg_radio[2], FALSE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(cfg_radio[2]),"toggled",GTK_SIGNAL_FUNC(toggle_button_callback),(gpointer)2);
  
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (cfg_radio[icons]), TRUE);


  table1 = gtk_table_new(11, 5, FALSE);
  gtk_object_set_data(GTK_OBJECT(config), "table1", table1);
  gtk_widget_show(table1);
  gtk_table_set_col_spacings(GTK_TABLE(table1), 3);

  tlabel2=gtk_label_new(_("Accounts"));
  gtk_widget_show(tlabel2);
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook1),table1,tlabel2);

  hbox3 = gtk_hbox_new(FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(config), "hbox3", hbox3);
  gtk_widget_show(hbox3);
  gtk_table_attach(GTK_TABLE(table1), hbox3, 0, 2, 10, 11,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  button_new = gtk_button_new_with_label(_("New"));
  gtk_object_set_data(GTK_OBJECT(config), "button_new", button_new);
  gtk_widget_show(button_new);
  gtk_box_pack_start(GTK_BOX(hbox3), button_new, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button_new),"clicked",GTK_SIGNAL_FUNC(new_account),NULL);

  button_del = gtk_button_new_with_label(_("Delete"));
  gtk_object_set_data(GTK_OBJECT(config), "button_del", button_del);
  gtk_widget_show(button_del);
  gtk_box_pack_start(GTK_BOX(hbox3), button_del, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(button_del),"clicked",GTK_SIGNAL_FUNC(del_account),NULL);

  hbox2 = gtk_hbox_new(TRUE, 0);
  gtk_object_set_data(GTK_OBJECT(config), "hbox2", hbox2);
  gtk_widget_show(hbox2);
  gtk_table_attach(GTK_TABLE(table1), hbox2, 3, 5, 10, 11,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  ent_filter = gtk_entry_new_with_max_length(50);
  gtk_object_set_data(GTK_OBJECT(config), "ent_filter", ent_filter);
  gtk_widget_show(ent_filter);
  gtk_table_attach(GTK_TABLE(table1), ent_filter, 4, 5, 4, 5,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_editable(GTK_ENTRY(ent_filter), FALSE);
  gtk_signal_connect(GTK_OBJECT(ent_filter),"focus_out_event",GTK_SIGNAL_FUNC(Folder_Filter),NULL);

  label18 = gtk_label_new(_("Filter script:"));
  gtk_object_set_data(GTK_OBJECT(config), "label18", label18);
  gtk_widget_show(label18);
  gtk_table_attach(GTK_TABLE(table1), label18, 3, 4, 4, 5,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label18), 1, 0.5);
  
  opt_foldertype = gtk_option_menu_new();
  gtk_object_set_data(GTK_OBJECT(config), "opt_foldertype", opt_foldertype);
  gtk_widget_show(opt_foldertype);
  gtk_table_attach(GTK_TABLE(table1), opt_foldertype, 4, 5, 3, 4,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
	   
  opt_foldertype_menu = gtk_menu_new();

  menuitem[0] = gtk_menu_item_new_with_label(_("Normal"));
  gtk_widget_show(menuitem[0]);
  gtk_signal_connect_object(GTK_OBJECT(menuitem[0]),"activate",GTK_SIGNAL_FUNC(Folder_Option_Change),(gpointer)0);
  gtk_menu_append(GTK_MENU(opt_foldertype_menu), menuitem[0]);
  
  menuitem[1] = gtk_menu_item_new_with_label(_("Inbox"));
  gtk_widget_show(menuitem[1]);
  gtk_signal_connect_object(GTK_OBJECT(menuitem[1]),"activate",GTK_SIGNAL_FUNC(Folder_Option_Change),(gpointer)1);
  gtk_menu_append(GTK_MENU(opt_foldertype_menu), menuitem[1]);

  menuitem[2] = gtk_menu_item_new_with_label(_("Outbox"));
  gtk_widget_show(menuitem[2]);
  gtk_signal_connect_object(GTK_OBJECT(menuitem[2]),"activate",GTK_SIGNAL_FUNC(Folder_Option_Change),(gpointer)2);
  gtk_menu_append(GTK_MENU(opt_foldertype_menu), menuitem[2]);

  menuitem[3] = gtk_menu_item_new_with_label(_("Sent mail"));
  gtk_widget_show(menuitem[3]);
  gtk_signal_connect_object(GTK_OBJECT(menuitem[3]),"activate",GTK_SIGNAL_FUNC(Folder_Option_Change),(gpointer)3);
  gtk_menu_append(GTK_MENU(opt_foldertype_menu), menuitem[3]);

  menuitem[4] = gtk_menu_item_new_with_label(_("Trash"));
  gtk_widget_show(menuitem[4]);
  gtk_signal_connect_object(GTK_OBJECT(menuitem[4]),"activate",GTK_SIGNAL_FUNC(Folder_Option_Change),(gpointer)4);
  gtk_menu_append(GTK_MENU(opt_foldertype_menu), menuitem[4]);

  menuitem[5] = gtk_menu_item_new_with_label(_("Filtered"));
  gtk_widget_show(menuitem[5]);
  gtk_signal_connect_object(GTK_OBJECT(menuitem[5]),"activate",GTK_SIGNAL_FUNC(Folder_Option_Change),(gpointer)5);
  gtk_menu_append(GTK_MENU(opt_foldertype_menu), menuitem[5]);

  gtk_option_menu_set_menu(GTK_OPTION_MENU(opt_foldertype), opt_foldertype_menu);

  label17 = gtk_label_new(_("Folder type:"));
  gtk_object_set_data(GTK_OBJECT(config), "label17", label17);
  gtk_widget_show(label17);
  gtk_table_attach(GTK_TABLE(table1), label17, 3, 4, 3, 4,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label17), 1, 0.5);

  ent_folderfile = gtk_entry_new_with_max_length(50);
  gtk_object_set_data(GTK_OBJECT(config), "ent_folderfile", ent_folderfile);
  gtk_widget_show(ent_folderfile);
  gtk_table_attach(GTK_TABLE(table1), ent_folderfile, 4, 5, 1, 2,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_signal_connect (GTK_OBJECT(ent_folderfile),"focus_out_event",GTK_SIGNAL_FUNC(Folder_File),NULL);

  label16 = gtk_label_new(_("Folder file:"));
  gtk_object_set_data(GTK_OBJECT(config), "label16", label16);
  gtk_widget_show(label16);
  gtk_table_attach(GTK_TABLE(table1), label16, 3, 4, 1, 2,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label16), 1, 0.5);

  label12 = gtk_label_new(_("Folder name:"));
  gtk_object_set_data(GTK_OBJECT(config), "label12", label12);
  gtk_widget_show(label12);
  gtk_table_attach(GTK_TABLE(table1), label12, 3, 4, 0, 1,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label12), 1, 0.5);

  but_newfolder = gtk_button_new_with_label(_("New"));
  gtk_object_set_data(GTK_OBJECT(config), "but_newfolder", but_newfolder);
  gtk_widget_show(but_newfolder);
  gtk_box_pack_start(GTK_BOX(hbox2), but_newfolder, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(but_newfolder),"clicked",GTK_SIGNAL_FUNC(new_folder),NULL);

  but_delfolder = gtk_button_new_with_label(_("Delete"));
  gtk_object_set_data(GTK_OBJECT(config), "but_delfolder", but_delfolder);
  gtk_widget_show(but_delfolder);
  gtk_box_pack_start(GTK_BOX(hbox2), but_delfolder, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(but_delfolder),"clicked",GTK_SIGNAL_FUNC(del_folder),NULL);

  combo_folder = gtk_combo_new();
  gtk_object_set_data(GTK_OBJECT(config), "combo_folder", combo_folder);
  gtk_table_attach(GTK_TABLE(table1), combo_folder, 4, 5, 0, 1,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  Update_FolderCombo(accdata[acur].foldata,accdata[acur].folders);
  gtk_signal_connect(GTK_OBJECT(GTK_LIST(GTK_COMBO(combo_folder)->list)),"selection_changed",GTK_SIGNAL_FUNC(FolderCombo_change),NULL);
  gtk_widget_show(combo_folder);

  vseparator1 = gtk_vseparator_new();
  gtk_object_set_data(GTK_OBJECT(config), "vseparator1", vseparator1);
  gtk_widget_show(vseparator1);
  gtk_table_attach(GTK_TABLE(table1), vseparator1, 2, 3, 0, 11,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 10, 5);

  chk_leave = gtk_check_button_new_with_label(_("Leave messages on server        "));
  gtk_object_set_data(GTK_OBJECT(config), "chk_leave", chk_leave);
  gtk_widget_show(chk_leave);
  gtk_table_attach(GTK_TABLE(table1), chk_leave, 0, 2, 8, 9,
                   GTK_EXPAND | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_signal_connect(GTK_OBJECT(chk_leave),"toggled",GTK_SIGNAL_FUNC(leave_toggle_button_callback),NULL);

  chk_trash = gtk_check_button_new_with_label(_("Move deleted msgs in Trash box"));
  gtk_object_set_data(GTK_OBJECT(config), "chk_trash", chk_trash);
  gtk_widget_show(chk_trash);
  gtk_table_attach(GTK_TABLE(table1), chk_trash, 0, 2, 9, 10,
                   GTK_EXPAND | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_signal_connect(GTK_OBJECT(chk_trash),"toggled",GTK_SIGNAL_FUNC(trash_toggle_button_callback),NULL);

  label11 = gtk_label_new(_("Password:"));
  gtk_object_set_data(GTK_OBJECT(config), "label11", label11);
  gtk_widget_show(label11);
  gtk_table_attach(GTK_TABLE(table1), label11, 0, 1, 7, 8,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label11), 1, 0.5);

  label10 = gtk_label_new(_("Username:"));
  gtk_object_set_data(GTK_OBJECT(config), "label10", label10);
  gtk_widget_show(label10);
  gtk_table_attach(GTK_TABLE(table1), label10, 0, 1, 6, 7,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label10), 1, 0.5);

  label9 = gtk_label_new(_("POP3 Mail server:"));
  gtk_object_set_data(GTK_OBJECT(config), "label9", label9);
  gtk_widget_show(label9);
  gtk_table_attach(GTK_TABLE(table1), label9, 0, 1, 5, 6,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label9), 1, 0.5);

  label8 = gtk_label_new(_("Organisation:"));
  gtk_object_set_data(GTK_OBJECT(config), "label8", label8);
  gtk_widget_show(label8);
  gtk_table_attach(GTK_TABLE(table1), label8, 0, 1, 4, 5,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label8), 1, 0.5);

  label7 = gtk_label_new(_("Full name:"));
  gtk_object_set_data(GTK_OBJECT(config), "label7", label7);
  gtk_widget_show(label7);
  gtk_table_attach(GTK_TABLE(table1), label7, 0, 1, 3, 4,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label7), 1, 0.5);

  label6 = gtk_label_new(_("Reply-to address:"));
  gtk_object_set_data(GTK_OBJECT(config), "label6", label6);
  gtk_widget_show(label6);
  gtk_table_attach(GTK_TABLE(table1), label6, 0, 1, 2, 3,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label6), 1, 0.5);

  label5 = gtk_label_new(_("Mail address:"));
  gtk_object_set_data(GTK_OBJECT(config), "label5", label5);
  gtk_widget_show(label5);
  gtk_table_attach(GTK_TABLE(table1), label5, 0, 1, 1, 2,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label5), 1, 0.5);

  label4 = gtk_label_new(_("Account name:"));
  gtk_object_set_data(GTK_OBJECT(config), "label4", label4);
  gtk_widget_show(label4);
  gtk_table_attach(GTK_TABLE(table1), label4, 0, 1, 0, 1,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label4), 1, 0.5);


  ent_password = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_password", ent_password);
  gtk_widget_show(ent_password);
  gtk_table_attach(GTK_TABLE(table1), ent_password, 1, 2, 7, 8,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  ent_username = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_username", ent_username);
  gtk_widget_show(ent_username);
  gtk_table_attach(GTK_TABLE(table1), ent_username, 1, 2, 6, 7,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);


  ent_pop3server = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_pop3server", ent_pop3server);
  gtk_widget_show(ent_pop3server);
  gtk_table_attach(GTK_TABLE(table1), ent_pop3server, 1, 2, 5, 6,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  ent_org = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_org", ent_org);
  gtk_widget_show(ent_org);
  gtk_table_attach(GTK_TABLE(table1), ent_org, 1, 2, 4, 5,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  ent_fullname = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_fullname", ent_fullname);
  gtk_widget_show(ent_fullname);
  gtk_table_attach(GTK_TABLE(table1), ent_fullname, 1, 2, 3, 4,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  ent_replyto = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_replyto", ent_replyto);
  gtk_widget_show(ent_replyto);
  gtk_table_attach(GTK_TABLE(table1), ent_replyto, 1, 2, 2, 3,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  ent_mail = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(config), "ent_mail", ent_mail);
  gtk_widget_show(ent_mail);
  gtk_table_attach(GTK_TABLE(table1), ent_mail, 1, 2, 1, 2,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  combo_acct = gtk_combo_new();
  gtk_object_set_data(GTK_OBJECT(config), "combo_acct", combo_acct);
  
  Update_Combo(accdata,accounts);

  gtk_widget_show(combo_acct);
  gtk_table_attach(GTK_TABLE(table1), combo_acct, 1, 2, 0, 1,
                   GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_signal_connect(GTK_OBJECT(GTK_LIST(GTK_COMBO(combo_acct)->list)),"selection_changed",GTK_SIGNAL_FUNC(Combo_change),NULL);
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(combo_acct)),"focus_in_event",GTK_SIGNAL_FUNC(RecSecond),NULL);
  gtk_signal_connect(GTK_OBJECT(GTK_ENTRY(GTK_COMBO(combo_acct)->entry)),"focus_in_event",GTK_SIGNAL_FUNC(RecSecond),NULL);
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(combo_acct)->button),"focus_in_event",GTK_SIGNAL_FUNC(RecSecond),NULL);

  dialog_action_area1 = GTK_DIALOG (config)->action_area;
  gtk_object_set_data(GTK_OBJECT(config), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show(dialog_action_area1);
  gtk_container_border_width(GTK_CONTAINER(dialog_action_area1), 7);

  button_ok = gtk_button_new_with_label(_("Ok"));
  gtk_object_set_data(GTK_OBJECT(config), "button_ok", button_ok);
  gtk_widget_show(button_ok);
  gtk_box_pack_start(GTK_BOX(dialog_action_area1), button_ok, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS(button_ok, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT(button_ok),"clicked",GTK_SIGNAL_FUNC(Ok_Close_Config),NULL);

  button_save = gtk_button_new_with_label(_("Save"));
  gtk_object_set_data(GTK_OBJECT(config), "button_save", button_save);
  gtk_widget_show(button_save);
  gtk_box_pack_start(GTK_BOX(dialog_action_area1), button_save, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS(button_save, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT(button_save),"clicked",GTK_SIGNAL_FUNC(Save_Close_Config),NULL);

  button_cancel = gtk_button_new_with_label(_("Cancel"));
  gtk_object_set_data(GTK_OBJECT(config), "button_cancel", button_cancel);
  gtk_widget_show(button_cancel);
  gtk_box_pack_start(GTK_BOX(dialog_action_area1), button_cancel, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS(button_cancel, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT(button_cancel),"clicked",GTK_SIGNAL_FUNC(Close_Config),NULL);

  Update_Config(acur);
  return config;
}


void hidemsgwin()
{
  gtk_widget_hide(msgwin);
}

GtkWidget*
create_msgwin ()
{
  GtkWidget *msgwin;
  GtkWidget *vpaned1;
  GtkWidget *vbox3;
  GtkWidget *msgmenubar;
  GtkWidget *msghandlebox;
  GtkWidget *fixed1;
  GtkWidget *but_rep;
  GtkWidget *but_frw;
  GtkWidget *but_del;
  GtkWidget *but_move;
  GtkWidget *but_copy;
  GtkWidget *but_decode;
  GtkWidget *but_save;
  GtkWidget *but_web;
  GtkWidget *table2;
  GtkWidget *label9;
  GtkWidget *label8;
  GtkWidget *label7;
  GtkWidget *label5;
  GtkWidget *label4;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *vscrollbar1;
  GtkWidget *box1;
  int i,d,j;


  msgwin = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_object_set_data(GTK_OBJECT(msgwin), "msgwin", msgwin);
  gtk_window_set_title(GTK_WINDOW(msgwin), _("Read Message"));
  gtk_window_position (GTK_WINDOW (msgwin), GTK_WIN_POS_CENTER);
  gtk_widget_set_usize(msgwin, -1, -1);
  gtk_window_set_policy(GTK_WINDOW(msgwin), TRUE, TRUE, FALSE);

  gtk_signal_connect(GTK_OBJECT(msgwin),"destroy",GTK_SIGNAL_FUNC(hidemsgwin),NULL);
  gtk_signal_connect(GTK_OBJECT(msgwin),"delete_event",GTK_SIGNAL_FUNC(hidemsgwin),NULL);

  vpaned1 = gtk_vpaned_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "vpaned1", vpaned1);
  gtk_widget_show(vpaned1);
  gtk_container_add(GTK_CONTAINER(msgwin), vpaned1);
  gtk_paned_handle_size(GTK_PANED(vpaned1), 0);
  gtk_paned_gutter_size(GTK_PANED(vpaned1), 13);

  vbox3 = gtk_vbox_new(FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(msgwin), "vbox3", vbox3);
  gtk_widget_show(vbox3);
  gtk_container_add(GTK_CONTAINER(vpaned1), vbox3);

  msgmenubar = gtk_menu_bar_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "msgmenubar", msgmenubar);
  gtk_widget_show(msgmenubar);
  gtk_box_pack_start(GTK_BOX(vbox3), msgmenubar, TRUE, TRUE, 0);

  msghandlebox = gtk_handle_box_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "msghandlebox", msghandlebox);
  gtk_widget_show(msghandlebox);
  gtk_box_pack_start(GTK_BOX(vbox3), msghandlebox, TRUE, TRUE, 1);
  if (butpixmaps==1) gtk_widget_set_usize(msghandlebox, -1, -1);
			    else gtk_widget_set_usize(msghandlebox, -1, 22);

  fixed1 = gtk_fixed_new();
  gtk_widget_show(fixed1);
  gtk_container_add(GTK_CONTAINER(msghandlebox), fixed1);
//  if (butpixmaps==1) gtk_widget_set_usize(fixed1, 450, -1);
//			    else gtk_widget_set_usize(fixed1, 450, 22);
  if (butpixmaps==1) gtk_widget_set_usize(fixed1, -1, -1);
			    else gtk_widget_set_usize(fixed1, -1, 22);

  but_rep = gtk_button_new ();
  box1 = xpm_label_box(fixed1,reply_xpm,_("Reply"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_rep),box1);
  gtk_widget_show(but_rep);

  if ((butpixmaps==1) && (butlabels==0)) j=10; else j=4;
  if ((butpixmaps==1) && (butlabels==0)) d=30; else d=60;
  i=1;
  gtk_fixed_put(GTK_FIXED(fixed1), but_rep, i, 0);
  my_set_usize(but_rep, 60, 22);
  gtk_signal_connect(GTK_OBJECT(but_rep),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)0);
  DoToolTips(but_rep,_("Reply to this message; does not work for now"));

  but_frw = gtk_button_new ();
  box1 = xpm_label_box(fixed1,forward_xpm,_("Forward"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_frw),box1);
  gtk_widget_show(but_frw);

  i+=d;  
  gtk_fixed_put(GTK_FIXED(fixed1), but_frw, i, 0);
  my_set_usize(but_frw, 60, 22);
  gtk_signal_connect(GTK_OBJECT(but_frw),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)1);
  DoToolTips(but_frw,_("Forward this message; does not work for now"));


  but_copy = gtk_button_new ();
  box1 = xpm_label_box(fixed1,copy_xpm,_("Copy"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_copy),box1);
  gtk_widget_show(but_copy);

  i+=d+j;
  gtk_fixed_put(GTK_FIXED(fixed1), but_copy, i, 0);
  my_set_usize(but_copy, 60, 22);
  gtk_signal_connect(GTK_OBJECT(but_copy),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)2);
  DoToolTips(but_copy,_("Copy this message to another folder"));



  but_move = gtk_button_new ();
  box1 = xpm_label_box(fixed1,move_xpm,_("Move"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_move),box1);
  gtk_widget_show(but_move);

  i+=d;  
  gtk_fixed_put(GTK_FIXED(fixed1), but_move, i, 0);
  my_set_usize(but_move, 60, 22);
  gtk_signal_connect(GTK_OBJECT(but_move),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)3);
  DoToolTips(but_move,_("Move this message to another folder"));


  but_del = gtk_button_new ();
  box1 = xpm_label_box(fixed1,delete_xpm,_("Delete"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_del),box1);
  gtk_widget_show(but_del);

  i+=d;  
  gtk_fixed_put(GTK_FIXED(fixed1), but_del, i, 0);
  my_set_usize(but_del, 60, 22);
  gtk_signal_connect(GTK_OBJECT(but_del),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)4);
  DoToolTips(but_del,_("Delete this message from folder"));

  but_decode = gtk_button_new ();
  box1 = xpm_label_box(fixed1,decode_xpm,_("Decode"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_decode),box1);
  gtk_widget_show(but_decode);
  
  i+=d+j;  
  gtk_fixed_put(GTK_FIXED(fixed1), but_decode, i, 0);
  my_set_usize(but_decode, 70, 22);
  gtk_signal_connect(GTK_OBJECT(but_decode),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)5);
  DoToolTips(but_decode,_("Decode this part of the message"));

  but_save = gtk_button_new ();
  box1 = xpm_label_box(fixed1,export_xpm,_("Export"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_save),box1);
  gtk_widget_show(but_save);

  i+=d; if (d==60) i+=10;
  gtk_fixed_put(GTK_FIXED(fixed1), but_save, i, 0);
  my_set_usize(but_save, 70, 22);
  gtk_signal_connect(GTK_OBJECT(but_save),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)6);
  DoToolTips(but_save,_("Save this message into a textfile"));

  but_web = gtk_button_new ();
  box1 = xpm_label_box(fixed1,html_xpm,_("Html"));
  gtk_widget_show(box1);
  gtk_container_add(GTK_CONTAINER(but_web),box1);
  gtk_widget_show(but_web);

  i+=d; if (d==60) i+=10;
  gtk_fixed_put(GTK_FIXED(fixed1), but_web, i, 0);
  my_set_usize(but_web, 70, 22);
  gtk_signal_connect(GTK_OBJECT(but_web),"clicked",GTK_SIGNAL_FUNC(msgmenu_func),(gpointer)7);
  DoToolTips(but_web,_("View this part in web browser"));

  table2 = gtk_table_new(3, 4, FALSE);
  gtk_object_set_data(GTK_OBJECT(msgwin), "table2", table2);
  gtk_widget_show(table2);
  gtk_box_pack_start(GTK_BOX(vbox3), table2, TRUE, TRUE, 0);

  ent_msgsubj = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "ent_msgsubj", ent_msgsubj);
  gtk_widget_show(ent_msgsubj);
  gtk_table_attach(GTK_TABLE(table2), ent_msgsubj, 1, 4, 2, 3,
                   GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_FILL, 0, 0);
  gtk_entry_set_editable(GTK_ENTRY(ent_msgsubj), FALSE);

  opt_msgparts = gtk_option_menu_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "opt_msgparts", opt_msgparts);
  gtk_widget_show(opt_msgparts);
  gtk_table_attach(GTK_TABLE(table2), opt_msgparts, 3, 4, 1, 2,
                   GTK_SHRINK | GTK_FILL, GTK_FILL, 0, 0);
  gtk_widget_set_usize(opt_msgparts, 100, 25);
  gtk_container_border_width(GTK_CONTAINER(opt_msgparts), 1);

  ent_msgdate = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "ent_msgdate", ent_msgdate);
  gtk_widget_show(ent_msgdate);
  gtk_table_attach(GTK_TABLE(table2), ent_msgdate, 3, 4, 0, 1,
                   GTK_FILL, GTK_FILL, 0, 0);
  gtk_widget_set_usize(ent_msgdate, 60, -1);
  gtk_entry_set_editable(GTK_ENTRY(ent_msgdate), FALSE);

  label9 = gtk_label_new(_("Subject:"));
  gtk_object_set_data(GTK_OBJECT(msgwin), "label9", label9);
  gtk_widget_show(label9);
  gtk_table_attach(GTK_TABLE(table2), label9, 0, 1, 2, 3,
                   GTK_FILL, GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label9), 1, 0.5);
  gtk_misc_set_padding(GTK_MISC(label9), 7, 0);

  label8 = gtk_label_new(_("Parts:"));
  gtk_object_set_data(GTK_OBJECT(msgwin), "label8", label8);
  gtk_widget_show(label8);
  gtk_table_attach(GTK_TABLE(table2), label8, 2, 3, 1, 2,
                   GTK_FILL, GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label8), 1, 0.5);
  gtk_misc_set_padding(GTK_MISC(label8), 7, 0);

  label7 = gtk_label_new(_("Date:"));
  gtk_object_set_data(GTK_OBJECT(msgwin), "label7", label7);
  gtk_widget_show(label7);
  gtk_table_attach(GTK_TABLE(table2), label7, 2, 3, 0, 1,
                   GTK_FILL, GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label7), 1, 0.5);
  gtk_misc_set_padding(GTK_MISC(label7), 7, 0);

  label5 = gtk_label_new(_("To:"));
  gtk_object_set_data(GTK_OBJECT(msgwin), "label5", label5);
  gtk_widget_show(label5);
  gtk_table_attach(GTK_TABLE(table2), label5, 0, 1, 1, 2,
                   GTK_FILL, GTK_FILL, 0, 0);
  gtk_widget_set_usize(label5, -1, 22);
  gtk_misc_set_alignment(GTK_MISC(label5), 1, 0.5);
  gtk_misc_set_padding(GTK_MISC(label5), 7, 0);

  label4 = gtk_label_new(_("From:"));
  gtk_object_set_data(GTK_OBJECT(msgwin), "label4", label4);
  gtk_widget_show(label4);
  gtk_table_attach(GTK_TABLE(table2), label4, 0, 1, 0, 1,
                   GTK_FILL, GTK_FILL, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label4), 1, 0.5);
  gtk_misc_set_padding(GTK_MISC(label4), 7, 0);

  ent_msgto = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "ent_msgto", ent_msgto);
  gtk_widget_show(ent_msgto);
  gtk_table_attach(GTK_TABLE(table2), ent_msgto, 1, 2, 1, 2,
                   GTK_SHRINK | GTK_FILL, GTK_FILL, 0, 0);
  gtk_widget_set_usize(ent_msgto, -1, 22);
  gtk_entry_set_editable(GTK_ENTRY(ent_msgto), FALSE);

  ent_msgfrom = gtk_entry_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "ent_msgfrom", ent_msgfrom);
  gtk_widget_show(ent_msgfrom);
  gtk_table_attach(GTK_TABLE(table2), ent_msgfrom, 1, 2, 0, 1,
                   GTK_SHRINK | GTK_FILL, GTK_FILL, 0, 0);
  gtk_entry_set_editable(GTK_ENTRY(ent_msgfrom), FALSE);

  vbox2 = gtk_vbox_new(FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(msgwin), "vbox2", vbox2);
  gtk_widget_show(vbox2);
  gtk_container_add(GTK_CONTAINER(vpaned1), vbox2);

  hbox1 = gtk_hbox_new(FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(msgwin), "hbox1", hbox1);
  gtk_widget_show(hbox1);
  gtk_box_pack_start(GTK_BOX(vbox2), hbox1, TRUE, TRUE, 0);

  msgtext = gtk_text_new(NULL, NULL);
  gtk_object_set_data(GTK_OBJECT(msgwin), "msgtext", msgtext);
  gtk_widget_show(msgtext);
  gtk_box_pack_start(GTK_BOX(hbox1), msgtext, TRUE, TRUE, 3);
  gtk_text_set_editable(GTK_TEXT(msgtext), FALSE);

  vscrollbar1=gtk_vscrollbar_new(GTK_TEXT(msgtext)->vadj);
  gtk_object_set_data(GTK_OBJECT(msgwin), "vscrollbar1", vscrollbar1);
  gtk_widget_show(vscrollbar1);
  gtk_box_pack_start(GTK_BOX(hbox1), vscrollbar1, FALSE, TRUE, 0);

  msgstatusbar = gtk_statusbar_new();
  gtk_object_set_data(GTK_OBJECT(msgwin), "msgstatusbar", msgstatusbar);
  gtk_widget_show(msgstatusbar);
  gtk_box_pack_start(GTK_BOX(vbox2), msgstatusbar, FALSE, TRUE, 0);

  return msgwin;
}



GtkWidget*
create_aboutwin ()
{
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox3;
  GtkWidget *label;
  GtkWidget *dialog_action_area1;
  GtkWidget *but_close;

  GtkWidget *pixmap1;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  aboutwin = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (aboutwin), "aboutwin", aboutwin);
  GTK_WINDOW (aboutwin)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_title (GTK_WINDOW (aboutwin), _("About Sandmail (tm)"));
  gtk_window_set_policy (GTK_WINDOW (aboutwin), FALSE, FALSE, TRUE);
  gtk_window_position (GTK_WINDOW (aboutwin), GTK_WIN_POS_CENTER);
  gtk_widget_realize(aboutwin);

  dialog_vbox1 = GTK_DIALOG (aboutwin)->vbox;
  gtk_object_set_data (GTK_OBJECT (aboutwin), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (aboutwin), "vbox3", vbox3);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox3, TRUE, TRUE, 0);



  style=gtk_widget_get_style(aboutwin);
  pixmap=gdk_pixmap_create_from_xpm_d(aboutwin->window,&mask,
							  &style->bg[GTK_STATE_NORMAL],(gchar **)logo_xpm);
  pixmap1=gtk_pixmap_new(pixmap,mask);
  gtk_widget_show(pixmap1);
  gtk_box_pack_start(GTK_BOX(vbox3),pixmap1,TRUE,TRUE,0);




  label = gtk_label_new (_("\npreview release 0.0008\nby Kemal 'Disq' Hadimli\n\ndisq@iname.com\n  http://artemis.efes.net/disq/sandmail  \n"));
  gtk_object_set_data (GTK_OBJECT (aboutwin), "label", label);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox3), label, TRUE, TRUE, 0);


  dialog_action_area1 = GTK_DIALOG (aboutwin)->action_area;
  gtk_object_set_data (GTK_OBJECT (aboutwin), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);

  but_close = gtk_button_new_with_label (_("Close"));
  gtk_object_set_data (GTK_OBJECT (aboutwin), "but_close", but_close);
  gtk_widget_show (but_close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), but_close, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (but_close), 5);
//  gtk_signal_connect(GTK_OBJECT(but_close),"clicked",GTK_SIGNAL_FUNC(Close_About),NULL);
  gtk_signal_connect_object(GTK_OBJECT(but_close),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(aboutwin));

  gtk_widget_show(aboutwin);
  return aboutwin;
}



GtkWidget*
create_cpy_win (int ismove)
{
  GtkWidget *but_cpy;
  GtkWidget *but_cancel;
  GtkWidget *dialog_vbox1;
  GtkWidget *table2;
  GtkWidget *label8;
  GtkWidget *label7;
  GtkWidget *hbox1;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label6;
  GtkWidget *dialog_action_area1;

  cpy_win = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (cpy_win), "cpy_win", cpy_win);
  GTK_WINDOW (cpy_win)->type = GTK_WINDOW_DIALOG;

  if (ismove==0)
    gtk_window_set_title (GTK_WINDOW (cpy_win), _("Copy message"));
  else
    gtk_window_set_title (GTK_WINDOW (cpy_win), _("Move message"));
	
  gtk_window_position (GTK_WINDOW (cpy_win), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (cpy_win), FALSE, FALSE, TRUE);
  gtk_signal_connect(GTK_OBJECT(cpy_win),"delete_event",GTK_SIGNAL_FUNC(dont_delete_event),NULL);

  dialog_vbox1 = GTK_DIALOG (cpy_win)->vbox;
  gtk_object_set_data (GTK_OBJECT (cpy_win), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  table2 = gtk_table_new (5, 2, FALSE);
  gtk_object_set_data (GTK_OBJECT (cpy_win), "table2", table2);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table2, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (table2), 5);

  cpy_ent_src = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (cpy_win), "cpy_ent_src", cpy_ent_src);
  gtk_widget_show (cpy_ent_src);
  gtk_table_attach (GTK_TABLE (table2), cpy_ent_src, 1, 2, 0, 1,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_set_usize (cpy_ent_src, 140, -1);
  gtk_entry_set_editable (GTK_ENTRY (cpy_ent_src), FALSE);

  label8 = gtk_label_new (_("Source:"));
  gtk_object_set_data (GTK_OBJECT (cpy_win), "label8", label8);
  gtk_widget_show (label8);
  gtk_table_attach (GTK_TABLE (table2), label8, 0, 1, 0, 1,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label8), 1, 0.5);
  gtk_misc_set_padding (GTK_MISC (label8), 3, 0);

  label7 = gtk_label_new (_("Pos:"));
  gtk_object_set_data (GTK_OBJECT (cpy_win), "label7", label7);
  gtk_widget_show (label7);
  gtk_table_attach (GTK_TABLE (table2), label7, 0, 1, 1, 2,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label7), 1, 0.5);
  gtk_misc_set_padding (GTK_MISC (label7), 3, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (cpy_win), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_table_attach (GTK_TABLE (table2), hbox1, 1, 2, 1, 2,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);

  cpy_ent_s = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (cpy_win), "cpy_ent_s", cpy_ent_s);
  gtk_widget_show (cpy_ent_s);
  gtk_box_pack_start (GTK_BOX (hbox1), cpy_ent_s, FALSE, TRUE, 0);
  gtk_widget_set_usize (cpy_ent_s, 60, -1);
  gtk_entry_set_editable (GTK_ENTRY (cpy_ent_s), FALSE);

  cpy_ent_e = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (cpy_win), "cpy_ent_e", cpy_ent_e);
  gtk_widget_show (cpy_ent_e);
  gtk_box_pack_start (GTK_BOX (hbox1), cpy_ent_e, FALSE, TRUE, 0);
  gtk_widget_set_usize (cpy_ent_e, 60, -1);
  gtk_entry_set_editable (GTK_ENTRY (cpy_ent_e), FALSE);

  cpy_opt_fld = gtk_option_menu_new ();
  gtk_object_set_data (GTK_OBJECT (cpy_win), "cpy_opt_fld", cpy_opt_fld);
  gtk_widget_show (cpy_opt_fld);
  gtk_table_attach (GTK_TABLE (table2), cpy_opt_fld, 1, 2, 4, 5,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_set_usize (cpy_opt_fld, -1, 25);
  cpy_opt_fld_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (cpy_opt_fld), cpy_opt_fld_menu);

  cpy_opt_acc = gtk_option_menu_new ();
  gtk_object_set_data (GTK_OBJECT (cpy_win), "cpy_opt_acc", cpy_opt_acc);
  gtk_widget_show (cpy_opt_acc);
  gtk_table_attach (GTK_TABLE (table2), cpy_opt_acc, 1, 2, 3, 4,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_set_usize (cpy_opt_acc, 150, 25);
  cpy_opt_acc_menu = gtk_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (cpy_opt_acc), cpy_opt_acc_menu);

  if (ismove==0)
    label3 = gtk_label_new (_("Copy message to:"));
  else
    label3 = gtk_label_new (_("Move message to:"));

  gtk_object_set_data (GTK_OBJECT (cpy_win), "label3", label3);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table2), label3, 0, 2, 2, 3,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label3), 0.5, 0.7);
  gtk_misc_set_padding (GTK_MISC (label3), 3, 15);

  label4 = gtk_label_new (_("Account:"));
  gtk_object_set_data (GTK_OBJECT (cpy_win), "label4", label4);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table2), label4, 0, 1, 3, 4,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_set_usize (label4, 80, 25);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label4), 1, 0.5);
  gtk_misc_set_padding (GTK_MISC (label4), 3, 0);

  label6 = gtk_label_new (_("Folder:"));
  gtk_object_set_data (GTK_OBJECT (cpy_win), "label6", label6);
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table2), label6, 0, 1, 4, 5,
                    GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_widget_set_usize (label6, 80, 25);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (label6), 1, 0.5);
  gtk_misc_set_padding (GTK_MISC (label6), 3, 0);

  dialog_action_area1 = GTK_DIALOG (cpy_win)->action_area;
  gtk_object_set_data (GTK_OBJECT (cpy_win), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  but_cpy = gtk_button_new_with_label (_("Copy"));
  gtk_object_set_data (GTK_OBJECT (cpy_win), "but_cpy", but_cpy);
  gtk_widget_show (but_cpy);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), but_cpy, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(but_cpy),"clicked",GTK_SIGNAL_FUNC(cpymove_do),(gpointer)ismove);

  but_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_object_set_data (GTK_OBJECT (cpy_win), "but_cancel", but_cancel);
  gtk_widget_show (but_cancel);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), but_cancel, TRUE, TRUE, 0);
  gtk_signal_connect_object(GTK_OBJECT(but_cancel),"clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(cpy_win));

  return cpy_win;
}
