#include "i18n.h"
#include <stdio.h>
#include <gtk/gtk.h>

typedef struct folderstruc {
 char name[50];
 unsigned int status;
 char filter[50]; 
 char file[50];
 GtkWidget *tree;
 } folderstruc;

typedef struct accstruc {
 char accname[50];
 char username[50];
 char password[50];
 char mailserver[50];
 char mailaddress[50];
 char replytoaddress[50];
 char fullname[50];
 char org[50];
 int leaveonserver;
 int movetotrash;
 
 unsigned int folders;
 folderstruc foldata[16];

 GtkWidget *tree;
 } accstruc;

int accounts, accountsbuf;
accstruc accdata[16],accbuf[16];

char smtpserver[50];
char webbrowser[50];
int autoweb;
int icons;

void cpyaccs(accstruc s[], int *sn, accstruc d[], int *dn)
{
  int i,j;

  dn[0]=sn[0];
  for(i=0;i<sn[0];i++)
	{
    strcpy(d[i].accname,s[i].accname);
    strcpy(d[i].username,s[i].username);
    strcpy(d[i].password,s[i].password);
	strcpy(d[i].mailserver,s[i].mailserver);
    strcpy(d[i].mailaddress,s[i].mailaddress);
	strcpy(d[i].replytoaddress,s[i].replytoaddress);
    strcpy(d[i].fullname,s[i].fullname);
	strcpy(d[i].org,s[i].org);
    d[i].leaveonserver=s[i].leaveonserver;
    d[i].movetotrash=s[i].movetotrash;
    d[i].folders=s[i].folders;
	for(j=0;j<s[i].folders;j++)
	  {
	  strcpy(d[i].foldata[j].name,s[i].foldata[j].name);
	  d[i].foldata[j].status=s[i].foldata[j].status;
	  strcpy(d[i].foldata[j].filter,s[i].foldata[j].filter);
	  strcpy(d[i].foldata[j].file,s[i].foldata[j].file);
	  }
	}
}

void readl(FILE *f, char line[])
{
int ch,p=0;
ch=fgetc(f);
while ((ch!='=') && (ch!='\n') && (!feof(f))) ch=fgetc(f);
if (ch=='=') ch=fgetc(f);
if ((ch=='\n') || (feof(f))) { line[0]=0; return; }
while ((ch!='\n') && (!feof(f)))
{
  line[p]=ch;
  p++;
  ch=fgetc(f);
}
line[p]=0;
//printf("\n%s",line); fflush(stdout);
}

void readconfig() {
char dummy[1024];
 FILE *f; int i,j; char a[128];

accounts=0;
smtpserver[0]=0;
webbrowser[0]=0;

sprintf(a,"%s/.sandmailrc",getenv("HOME"));
f=fopen(a,"r");
if (f==NULL) return;

readl(f,dummy);
readl(f,dummy);
icons=atoi(dummy);
readl(f,smtpserver);
readl(f,webbrowser);
readl(f,dummy);
autoweb=atoi(dummy);
readl(f,dummy);
accounts=atoi(dummy);

for(i=0;((i<accounts) && (!feof(f)));i++) {
readl(f,dummy);
readl(f,accdata[i].accname);
readl(f,accdata[i].username);
readl(f,accdata[i].password);
readl(f,accdata[i].mailserver);
readl(f,accdata[i].mailaddress);
readl(f,accdata[i].replytoaddress);
readl(f,accdata[i].fullname);
readl(f,accdata[i].org);
readl(f,dummy); accdata[i].leaveonserver=atoi(dummy);
readl(f,dummy); accdata[i].movetotrash=atoi(dummy);

readl(f,dummy);
accdata[i].folders=atoi(dummy);
for(j=0;j<accdata[i].folders;j++)
  {
  readl(f,accdata[i].foldata[j].name);
  readl(f,accdata[i].foldata[j].file);
  readl(f,dummy);
  accdata[i].foldata[j].status=atoi(dummy);
  if (accdata[i].foldata[j].status==5) readl(f,accdata[i].foldata[j].filter);
    else strcpy(accdata[i].foldata[j].filter,"");
  }
}
if (i<accounts) accounts=i;

fclose(f);
}


void writeconfig() {
FILE *f; int i,j; char a[128];

sprintf(a,"%s/.sandmailrc",getenv("HOME"));
f=fopen(a,"w");
if (f==NULL) { puts(_("error writing config file")); return; }

fprintf(f,"Comment=This is Sandmail config file. DO NOT EDIT!\n");
fprintf(f,"ToolbarStatus=%i\n",icons);
fprintf(f,"SMTP Server=%s\n",smtpserver);
fprintf(f,"Web Browser=%s\n",webbrowser);
fprintf(f,"Autoweb=%i\n",autoweb);
fprintf(f,"Accounts=%i\n",accounts);

for(i=0;(i<accounts);i++) {
fprintf(f,"\n");
fprintf(f,"Account name=%s\n",accdata[i].accname);
fprintf(f,"Username=%s\n",accdata[i].username);
fprintf(f,"Password=%s\n",accdata[i].password);
fprintf(f,"POP3 server=%s\n",accdata[i].mailserver);
fprintf(f,"Mail address=%s\n",accdata[i].mailaddress);
fprintf(f,"Reply-to address=%s\n",accdata[i].replytoaddress);
fprintf(f,"Full name=%s\n",accdata[i].fullname);
fprintf(f,"Organisation=%s\n",accdata[i].org);
fprintf(f,"Leave on server=%i\n",accdata[i].leaveonserver);
fprintf(f,"Move messages to Trash on delete=%i\n",accdata[i].movetotrash);
fprintf(f,"Folders=%i\n",accdata[i].folders);
for(j=0;j<accdata[i].folders;j++)
  {
  fprintf(f,"Folder=%s\n",accdata[i].foldata[j].name);
  fprintf(f,"File=%s\n",accdata[i].foldata[j].file);
  fprintf(f,"Status=%i\n",accdata[i].foldata[j].status);
  if (accdata[i].foldata[j].status==5) fprintf(f,"Filter=%s\n",accdata[i].foldata[j].filter);
  }
}

fclose(f);
}
